--RaceCheckPoint.
--by aarbro [aarbro@hotmail.com]


RaceCheckPoint = {

	Editor = {
		Model="Objects/EXP/Editor/editor_checkpoint.cgf",
	},

	Properties = {
		bStart = 0,
		bFinish = 0,
		bSilent = 0,
		TrackName = "",
	},
	
	active = 0,
	racetrack = nil,
};
-------------------------------------------------------------------------------
function RaceCheckPoint:OnPropertyChange()
	self:OnReset();
end
-------------------------------------------------------------------------------

function RaceCheckPoint:OnInit()
	self:OnReset();
end
-------------------------------------------------------------------------------

function RaceCheckPoint:OnReset()

	self:TrackColliders(1);
	self.active = 0;

end

-------------------------------------------------------------------------------
function RaceCheckPoint:OnShutDown()
end
-------------------------------------------------------------------------------

function RaceCheckPoint:OnSave(stm)
end
-------------------------------------------------------------------------------

function RaceCheckPoint:OnLoad(stm)
end
-------------------------------------------------------------------------------

function RaceCheckPoint:OnEnterArea( player,areaId )
	
	self.racetrack = System:GetEntityByName( self.Properties.TrackName );

	if ( self.active == 1 ) then
		if ( self.Properties.bFinish == 1 ) then
			self.racetrack.laps = self.racetrack.laps - 1;
			if ( self.racetrack.laps == 0 ) then --finished
				self.racetrack:OnRaceFinished( self );
				self.racetrack.racing = 0;
			else --laps left,
				self.racetrack:OnLapPoint( self );
			end
		else --RaceCheckPoint
			self.racetrack:OnCheckPoint( self );
		end
	else --inactive, either the race just started or a missed checkpoint
		if ( self.Properties.bStart == 1 and self.racetrack.racing == 0 ) then
			self.racetrack:OnRaceStarted( self );
			self.active = 1;
			self.racetrack.racing = 1;
			self.racetrack.laps = self.racetrack.Properties.Laps;
		else
			self.racetrack:OnMissedCheckPoint( self );
		end
	end	
		
	--activate next if it's goal and laps left or a normal RaceCheckPoint
	if ( self.active == 1 ) then
		if ( ( self.Properties.bFinish == 1 and self.racetrack.laps > 0 ) or self.Properties.bFinish == 0 ) then 
			BroadcastEvent(self, "Next"); --activate next
  	end
  end
  self.active = 0;

end
-------------------------------------------------------------------------------
function RaceCheckPoint:OnLeaveArea( player,areaId )
end
-------------------------------------------------------------------------------
function RaceCheckPoint:Event_Next() --Now this RCP is active
	self.active = 1;
end
-------------------------------------------------------------------------------
