Script:LoadScript("scripts/default/entities/pickups/basepickup.lua");

local funcPick=function (self,collider,entering)			

	if GameRules and GameRules.OnClassAmmoPickup then
		if GameRules:OnClassAmmoPickup(collider, self.Properties.IsDropPack) then
			--self:NotifyMessage("@YouPickedUp @Ammo",collider);		-- we should optimize this
			
			-- send armor catch 
			local serverSlot = Server:GetServerSlotByEntityId(collider.id);
			if (serverSlot) then	
				serverSlot:SendCommand("HUD P 8 1"); -- hud, generic pick (assault mp mode)
			end
			
			return 1;												-- remove entity
		end
	end

	if (entering == 1) then
		if ((not self.lasttime) or (_time>(self.lasttime+6))) then		
			--self:NotifyMessage("@pickup_not_possible @ammo_pickup_not_possible_trail", collider);
			
			-- send ammo cannot catch 
			local serverSlot = Server:GetServerSlotByEntityId(collider.id);
			if (serverSlot) then
				serverSlot:SendCommand("HUD P 8 -1"); -- hud, generic pick, armor, not available
			end
										
			self.lasttime=_time;
		end
	end
	return nil;
end

local params={
	func=funcPick,
	model="Objects/Pickups/universal_ammo/universal_ammo.cgf",
	default_amount=15,
	sound="Sounds/Weapons/M4/M4_33.wav",							-- todo change sound?
	modelchoosable=1,
	soundchoosable=1,
	floating_icon="Objects/Pickups/universal_ammo/universal_ammo_icon.cga",
	objectpos = {x=0, y=0, z=-0.08},
}

ClassAmmoPickup=CreateCustomPickup(params);
ClassAmmoPickup.Properties.Amount=nil;
--3up change
--ClassAmmoPickup.Properties.RespawnTime=20;
--ClassAmmoPickup.Properties.IsDropPack = nil;
--ClassAmmoPickup.Properties.AlwaysPhysicalize = 1;

ClassAmmoPickup.Client.OnInit=function(self)
	BasePickup.Client.OnInit(self);
end

function ClassAmmoPickup:OnPropertyChange()
	self:LoadObject(self.Properties.object_Model, 0, 1);
	self:DrawObject( 0, 1 );
	self.soundobj=Sound:LoadSound(self.Properties.sound_Sound);
end


--3up change start to EOF
ClassAmmoPickup.PhysParam = {
	mass = 10,
	size = 0.15,
	heading = {x=0,y=0,z=-1},
	initial_velocity = 6,
	k_air_resistance = 0,
	acc_thrust = 0,
	acc_lift = 0,
	--high friction material
	surface_idx = Game:GetMaterialIDByName("mat_pickup"),
	gravity = {x=0, y=0, z=-9.8 },
	collider_to_ignore = nil,
	flags = bor(particle_constant_orientation,particle_no_path_alignment, particle_no_roll, particle_traceable),
}

function ClassAmmoPickup:Launch( weapon, shooter, pos, angles, dir, target )

	self:SetPhysicParams( PHYSICPARAM_PARTICLE, self.PhysParam );
	self.autodelete = 1;
	self.deleteOnGameReset = 1;
	self:EnableSave(nil);
	self:GotoState("Dropped");
	-- fade away after 15 seconds
	self.Properties.FadeTime = 15;
	self.Properties.Amount = 30;
--	self:SetTimer(15000);


	local direction = g_Vectors.temp_v1;
	local dest = g_Vectors.temp_v2;
		
	CopyVector(direction,dir);
		
	dest.x = pos.x + direction.x * 1.5;
	dest.y = pos.y + direction.y * 1.5;
	dest.z = pos.z + direction.z * 1.5;
		
	local hits = System:RayWorldIntersection(pos,dest,1,ent_terrain+ent_static+ent_rigid+ent_sleeping_rigid,shooter.id);
		
	if (hits and getn(hits)>0) then
			
		local temp = hits[1].pos;
		
		dest.x = temp.x - direction.x * 0.15;
		dest.y = temp.y - direction.y * 0.15;
		dest.z = temp.z - direction.z * 0.15;
	end
	
	shooter:AwakeEnvironment();

	self:SetPos( dest );--pos );
	self:SetAngles( angles );
	self:NetPresent(1);
	
	-- the ID of the server slot who initiated the action
	-- used for statistics
	local serverSlot = Server:GetServerSlotByEntityId(shooter.id);
	
	if (serverSlot) then
		self.shooterSSID = serverSlot:GetId();
	end
	
	self.LaunchedByTeam=Game:GetEntityTeam(shooter.id);
end

