Script:LoadScript("scripts/default/entities/weapons/BaseProjectile.lua");

projectileDefinition = {
	Param = {
		mass = 1,
		size = 0.15,
		heading = {},
		flags=1,
		initial_velocity = 60,
		k_air_resistance = 0,
		acc_thrust = 0,
		acc_lift = 0,
		surface_idx = -1,
		gravity = {x=0, y=0, z=1*-9.8 },
		collider_to_ignore = nil,
		AI_Type = AIOBJECT_ATTRIBUTE,
	},

	ExplosionParams = {
		pos = {},
		damage = 150,
		rmin = 1.5,
		rmax = 1.5, -- default = 10.5 
		radius = 1.5, -- default = 8
		DeafnessRadius = 0.5,
		DeafnessTime = 1.0,
		impulsive_pressure = 100, -- default 5
		shooter = nil,
		weapon = nil,
		explosion = 1,
		rmin_occlusion=0.2,
		occlusion_res=2,
		inflate=1,
	},
	
	Smoke = {
		focus = 5,
		speed = 0.3,
		rotation = { X=0,Y=0,Z=2},
		count = 1,
		size = 0.2, size_speed=2,
		lifetime=2.0,
		frames=1,
		tid = System:LoadTexture("textures/dust_smoke2.DDS"),
	},
	
	EngineSound = {
		name = "sounds/items/throw.wav",
		minDist = 5,
		maxDist = 100000,
	},

	hit_effect = "tiny_explosion",
	explode_effect = "tiny_explosion",
	matEffect = "tiny_explosion",
	
	explodeOnContact = 1,
	--useAIProjectileShoot = 1,
	--force_objtype = 2,
	projectileObject = "Objects/Natural/ROCKS/smallrock/smallrockh.cgf",
	projectileObjectScale = 0.1,

}

SnowShell = CreateProjectile(projectileDefinition);