UI.PageMultiplayer =
{
    FavServers = {},
    
    --UI.PageMultiplayer.FavServers[1] = "192.168.1.1";
    --UI.PageMultiplayer.FavServers[2] = "192.168.1.2";
    --UI.PageMultiplayer.FavServers[3] = "192.168.1.3";
    --UI.PageMultiplayer.FavServers[4] = "192.168.1.4";
    
    GUI=
    {
        LAN=
        {
            skin = UI.skins.TopMenuButton,

            tabstop = 1,

            text = Localize("LAN"),

            greyedcolor = UI.szTabAdditiveColor,
            greyedblend = UIBLEND_ADDITIVE,

            OnCommand = function(Sender)

                UI:DeactivateScreen("NETServerList");
                UI:ActivateScreen("LANServerList");

                UI:DisableWidget(Sender);
                UI:EnableWidget("NET", "Multiplayer");

                UI.PageMultiplayer.CurrentList = UI.PageLANServerList;
                
                UI.PageMultiplayer.GUI.Join.OnCommand = UI.PageMultiplayer.CurrentList.GUI.ServerList.OnCommand;

                UI:HideWidget(UI.PageMultiplayer.GUI.Logout);
                UI:EnableWidget(UI.PageMultiplayer.GUI.Refresh);

                UI.PageMultiplayer.GUI.LAN.skin.OnLostFocus(UI.PageMultiplayer.GUI.LAN);
                UI.PageMultiplayer.GUI.NET.skin.OnLostFocus(UI.PageMultiplayer.GUI.NET);
                
                UI.PageMultiplayer.szLastMultiplayerMenu = "LAN";
            end,
        },

        NET=
        {
            skin = UI.skins.TopMenuButton,

            tabstop = 2,

            left = 200 + 179,
            
            text = Localize("Internet"),

            greyedcolor = UI.szTabAdditiveColor,
            greyedblend = UIBLEND_ADDITIVE,

            OnCommand = function(Sender)

                UI:DeactivateScreen("LANServerList");
                UI:ActivateScreen("NETServerList");

                UI:DisableWidget(Sender);
                UI:EnableWidget("LAN", "Multiplayer");

                UI:ShowWidget(UI.PageMultiplayer.GUI.Logout);

                UI.PageMultiplayer.CurrentList = UI.PageNETServerList;

                UI.PageMultiplayer.GUI.Join.OnCommand = UI.PageMultiplayer.CurrentList.GUI.ServerList.OnCommand;

                if (not NewUbisoftClient:Client_IsConnected()) then
                    NewUbisoftClient:Login();
                end

                UI.PageMultiplayer.GUI.LAN.skin.OnLostFocus(UI.PageMultiplayer.GUI.LAN);
                UI.PageMultiplayer.GUI.NET.skin.OnLostFocus(UI.PageMultiplayer.GUI.NET);
                
                UI.PageMultiplayer.szLastMultiplayerMenu = "NET";
            end,
        },
        
        FavoritesText=
        {
            skin = UI.skins.Label,
            
            left = 379,
            top = 135, width = 60,
            
            halign = UIALIGN_LEFT,
            
            text = "Favorites",
        },
        
        AddToFavorites=
        {
            skin = UI.skins.TopMenuButton,

            tabstop = 2,

            left = 441,
            top = 135, width = 40,
            
            text = "Add",

            greyedcolor = UI.szTabAdditiveColor,
            greyedblend = UIBLEND_ADDITIVE,

            OnCommand = function(Sender)
                UI.PageMultiplayer.SaveServerToFavorites();
            end,
        },        
        
        DeleteFromFavorites=
        {
            skin = UI.skins.TopMenuButton,

            tabstop = 2,

            left = 483,
            top = 135, width = 40,
            
            text = "Del",

            greyedcolor = UI.szTabAdditiveColor,
            greyedblend = UIBLEND_ADDITIVE,

            OnCommand = function(Sender)
                UI.PageMultiplayer.DeleteServerFromFavorites();
            end,
        },
        
        FilterFavorites=
        {
            skin = UI.skins.CheckBox,
            
            left = 525, height = 24,
            top = 135, width = 24,
            
            tabstop = 34,
            
            OnChanged = function(self)
                Game:ClearServerInfo();
                UI.PageNETServerList.GUI.ServerList:Clear();
                UI.PageMultiplayer.CurrentList.RefreshList();
            end,
        },        
        
        Create=
        {
            skin = UI.skins.TopMenuButton,
            
            tabstop = 3,
            
            left = 200+179+179,

            text = Localize("Create"),

            greyedcolor = UI.szTabAdditiveColor,
            greyedblend = UIBLEND_ADDITIVE,
            
            OnCommand = function(Sender)

                if (UI.PageMultiplayer.CurrentList == UI.PageNETServerList) then
                    setglobal("sv_ServerType","UBI");
                elseif (UI.PageMultiplayer.CurrentList == UI.PageLANServerList) then
                    setglobal("sv_ServerType","LAN");
                end

                if (UI:WillTerminate()) then
                    UI.YesNoBox(Localize("TerminateCurrentGame"), Localize("TerminateCurrentGameLabel"), UI.PageMultiplayer.CreateServer);
                else
                    UI.PageMultiplayer.CreateServer();
                end
            end
        },        

        Logout =
        {
            skin = UI.skins.BottomMenuButton,
            left = 25,
            width = 163,
            top = 480.5,
            
            bordersides = "",
            fontsize = 15,

            tabstop = 4,

            text = "@UBILogout",

            OnCommand = function(Sender)
                if (UI:WillTerminate()) then
                    UI.YesNoBox(Localize("TerminateCurrentGame"), Localize("TerminateCurrentGameLabel"), UI.PageMultiplayer.LogoutUBI);
                else
                    UI.PageMultiplayer.LogoutUBI();
                end
            end
        },

        PunkBusterText=
        {
            skin = UI.skins.Label,
            left =314, top = 480,
            width = 122,
            
            text = Localize("EnablePBClient");
        },
        
        PunkBuster=
        {
            skin = UI.skins.CheckBox,
            left = 444, top = 480,
            
            tabstop = 5,
            
            OnChanged = function(self)
                if(self:GetChecked()) then
                    setglobal("cl_punkbuster", 1);
                    setglobal("sv_punkbuster", 1);
                else
                    setglobal("cl_punkbuster", 0);
                    setglobal("sv_punkbuster", 0);
                end
            end,
        },
        
        Refresh=
        {
            skin = UI.skins.BottomMenuButton,
            left = 500.5,
            width = 140,
            top = 480,

            tabstop = 6,

            text = Localize("Refresh"),

            OnCommand = function(Sender)
                UI.PageMultiplayer.CurrentList.RefreshList();
            end
        },


        Join =
        {
            skin = UI.skins.BottomMenuButton,
            left = 640.5,
            width = 140,
            top = 480,
            
            tabstop = 7,

            text = Localize("Join"),
        },
        
        OnActivate = function(Sender)

            if ((UI.PageMultiplayer.szLastMultiplayerMenu == "NET") and (NewUbisoftClient and NewUbisoftClient:Client_IsConnected())) then
                Sender.NET.OnCommand(Sender.NET);
            else
                Sender.LAN.OnCommand(Sender.LAN);
            end
            
            if (cl_punkbuster and tonumber(cl_punkbuster) ~= 0) then
                Sender.PunkBuster:SetChecked(1);
            else
                Sender.PunkBuster:SetChecked(0);
            end

            UI:DisableWidget(UI.PageMultiplayer.GUI.Join);

            if (UI.PageMultiplayer.CurrentList) then
                local ServerList = UI.PageMultiplayer.CurrentList.GUI.ServerList;

                if (ServerList:GetSelectionCount() > 0) then
                    UI:EnableWidget(UI.PageMultiplayer.GUI.Join);
                else
                    UI:DisableWidget(UI.PageMultiplayer.GUI.Join);
                end
            end

            if( NewUbisoftClient ) then
                NewUbisoftClient.szCurrentUbiName = szName;
                NewUbisoftClient.szCurrentUbiPass = szPassword;
            end;
               
            UI.PageMultiplayer.LoadFavorites();
            UI.PageNETServerList.iCurrentLobby = 0;
        end,
    },

    CreateServer = function()
        Game:Disconnect();
        GotoPage("CreateServer");
    end,
    
    LoadFavorites = function ()
        if (count(UI.PageMultiplayer.FavServers) > 0) then
            for ServerIndex=1, count(UI.PageMultiplayer.FavServers) do
                UI.PageMultiplayer.FavServers[ServerIndex] = nil;
            end
        end
        
        UI.PageMultiplayer.szLoadFileName = "profiles/server/fav_server.cfg";
        
        local hfile = openfile(UI.PageMultiplayer.szLoadFileName, "r");

        if (hfile) then
            closefile(hfile);

            Script:LoadScript(UI.PageMultiplayer.szLoadFileName, 1);
        end
    end,
    
    DeleteServerFromFavorites = function() 
        UI.PageMultiplayer.LoadFavorites();

        UI.PageMultiplayer.szSaveFileName = "profiles/server/fav_server.cfg";        

        local hFile = openfile (UI.PageMultiplayer.szSaveFileName, "r");
        local TempSelection = tonumber(getglobal("g_FavServerIP"));

        local NumOfFavs = count(UI.PageMultiplayer.FavServers);
        NumOfFavs = NumOfFavs + 1;

        local MyIPIwant = UI.PageNETServerList.Servers[TempSelection].IP;
        setglobal("g_FavServerIP", MyIPIwant);

        if (hFile) then
            closefile(hFile);

            hFile = openfile(UI.PageMultiplayer.szSaveFileName, "w");
            
            local MyIndex = 1;
            
            if (count(UI.PageMultiplayer.FavServers) > 0) then
                for ServerIndex=1, count(UI.PageMultiplayer.FavServers) do
                    local TestIP = UI.PageMultiplayer.FavServers[ServerIndex];
                    
                    if (TestIP ~= MyIPIwant) then
                        write(hFile, "UI.PageMultiplayer.FavServers["..MyIndex.."] = "..format('%q', TestIP).."\n");
                        MyIndex = MyIndex + 1;
                    end
                end
            end
            closefile(hFile);
        end

        UI.PageMultiplayer.CurrentList.RefreshList();
    end,    

    SaveServerToFavorites = function() 
        UI.PageMultiplayer.LoadFavorites();

        UI.PageMultiplayer.szSaveFileName = "profiles/server/fav_server.cfg";        

        
        local TempSelection = tonumber(getglobal("g_FavServerIP"));
        local bDuplicate = 0;
        local NumOfFavs = count(UI.PageMultiplayer.FavServers);
        
        NumOfFavs = NumOfFavs + 1;

        local MyIPIwant = UI.PageNETServerList.Servers[TempSelection].IP;
        setglobal("g_FavServerIP", MyIPIwant);


        hFile = openfile(UI.PageMultiplayer.szSaveFileName, "w");

        if (count(UI.PageMultiplayer.FavServers) > 0) then
            for ServerIndex=1, count(UI.PageMultiplayer.FavServers) do
                local TestIP = UI.PageMultiplayer.FavServers[ServerIndex];
                if (TestIP == MyIPIwant) then
                    bDuplicate = 1;
                end
                write(hFile, "UI.PageMultiplayer.FavServers["..ServerIndex.."] = "..format('%q', TestIP).."\n");
            end
            if (bDuplicate == 0) then
                write(hFile, "UI.PageMultiplayer.FavServers["..NumOfFavs.."] = "..format('%q', MyIPIwant).."\n");
            end
        else
            write(hFile, "UI.PageMultiplayer.FavServers[1] = "..format('%q', MyIPIwant).."\n");
        end
        closefile(hFile);

        UI.PageMultiplayer.LoadFavorites();        
    end, 
    
    LogoutUBI = function()
        UI.MessageBox(Localize("UBIcomInfo"),Localize("DisconnectingFromService"),nil);
        NewUbisoftClient.szCurrentUbiName = szName;
        NewUbisoftClient.szCurrentUbiPass = szPassword;
        Game:Disconnect();
        NewUbisoftClient:Client_Disconnect();
        UI.PageMultiplayer.GUI.LAN.OnCommand(UI.PageMultiplayer.GUI.LAN);
    end,

    OnLoginOk = function (szName, szPassword, bSavePassword)
        if (szName and szPassword) then
            if (strlen(szName) > 0 and strlen(szPassword) > 0) then

                local bLoginResult = NewUbisoftClient:Client_Login(szName, szPassword, bSavePassword);

                if (not bLoginResult) then
                    return 1;
                end

                NewUbisoftClient.szCurrentError = nil;
                NewUbisoftClient.szCurrentUbiName = szName;
                NewUbisoftClient.szCurrentUbiPass = szPassword;

                if (bSavePassword and tonumber(bSavePassword) ~= 0) then
                    setglobal("cl_saveubipassword", 1);
                else
                    setglobal("cl_saveubipassword", 0);
                end

                UI.ProgressBox(Localize("PleaseWait"), Localize("LoggingIn"), UI.PageMultiplayer.CancelLogin);

                return 1;
            end
        end
            
        local szError = "@UbiTypeUsername";

        if (szName and (strlen(szName) > 0)) then
            szError = "@UbiTypePassword";
        end
        
        if (szPassword and (strlen(szPassword) > 0)) then
            szError = "@UbiTypeUsername";
        end

        NewUbisoftClient.szCurrentUbiName = szName;
        NewUbisoftClient.szCurrentUbiPass = szPassword;

        UI.MessageBox("@UBIcomInfo", szError, UI.PageMultiplayer.RetypeRelogin);

        return 1;
    end,
    
    RetypeRelogin = function()
        NewUbisoftClient:Login();
    end,

    OnLoginCancel = function(Name, Password)
        NewUbisoftClient:Client_Disconnect();

        if (UI:IsScreenActive("Multiplayer") == 1) then
            UI.PageMultiplayer.GUI.LAN.OnCommand(UI.PageMultiplayer.GUI.LAN);
        end

        UI.bNeedUbiReconnect = nil;
        
        return 1;
    end,

    CancelLogin = function()
        NewUbisoftClient:Client_Disconnect();

        if (UI:IsScreenActive("Multiplayer") == 1) then
            UI.PageMultiplayer.GUI.LAN.OnCommand(UI.PageMultiplayer.GUI.LAN);
        end
        
        UI.bNeedUbiReconnect = nil;
    end,

    CancelCDKey = function()
        UI.bVerifyingProgress = nil;
        NewUbisoftClient:Client_Disconnect();

        if (UI:IsScreenActive("Multiplayer") == 1) then
            GotoPage("Multiplayer", 0);
            UI.PageMultiplayer.GUI.LAN.OnCommand(UI.PageMultiplayer.GUI.LAN);
        else
            GotoPage("Multiplayer", 0);
            UI.PageMultiplayer.GUI.LAN.OnCommand(UI.PageMultiplayer.GUI.LAN);
        end
        UI.bNeedUbiReconnect = nil;

        return 1;
    end,

    OnCDKeyOk = function(szCDKey)
        if (szCDKey and (strlen(szCDKey) > 0)) then
            NewUbisoftClient:Client_SetCDKey(szCDKey);
            UI.bVerifyingProgress = 1;

            UI.ProgressBox(Localize("PleaseWait"), Localize("VerifyingCDKey"), UI.PageMultiplayer.CancelCDKey);
            return 1;
        end
    end,

    CurrentList = nil,
    bLoggingIn = nil,
}

AddUISideMenu(UI.PageMultiplayer.GUI,
{
    { "MainMenu", Localize("MainMenu"), "$MainScreen$", 0},
    { "Options", Localize("Options"), "Options", 0},
});

UI:CreateScreenFromTable("Multiplayer",UI.PageMultiplayer.GUI);