--
-- Handler for new sv_* commands
--
ServerCmds = {};

--
-- Handler for \sv_say command
--
function ServerCmds:Say(message)
	Server:BroadcastText(message);
end
Game:AddCommand("sv_say","ServerCmds:Say(%line);","Say in public");


function ServerCmds:Anni(toggle)
	if (toNumberOrZero(toggle) == 1) then
		setglobal("gr_Lockdown", "1");										
		setglobal("gr_Lockdowntime", "240");										
		setglobal("gr_MaxDeathLimit", "4");	
		setglobal("gr_TimeLimit", "7");	
	else
		setglobal("gr_Lockdown", "0");										
		setglobal("gr_Lockdowntime", "180");										
		setglobal("gr_MaxDeathLimit", "0");	
		setglobal("gr_TimeLimit", "20");	
	end
end
Game:AddCommand("sv_anni","ServerCmds:Anni(%1);","sv_anni <onoff>");





function ServerCmds:nextMap()
	System:ExecuteCommand("sv_changemap "..tostring(getglobal("gr_NextMap")).." "..tostring(getglobal("g_GameType")));
end
Game:AddCommand("sv_nextmap","MapCycle:LNextMap();","sv_nextmap");

function ServerCmds:forceTeamChangeById(id, team)
	local slot = Server:GetServerSlotBySSId(id);
	if slot and team then
		ServerCmds:HandleJoinTeamRequest(slot,team,true);
	else
		System:LogAlways("ServerCmds:forceTeamChangeById: invalid id");
	end
end
Game:AddCommand("sv_forceteamid","ServerCmds:forceTeamChangeById(%1, %2);","sv_forceteamid");


function ServerCmds:HandleJoinTeamRequest(server_slot,new_team,force)
	
	GameRules:ChangeTeam(server_slot,new_team, force);
	
	if(new_team=="spectators" or new_team=="players")then
	  Server:BroadcastText(server_slot:GetName().."$o @HasJoinedThe "..GameRules.TeamText[new_team]);
	else
	  Server:BroadcastText(server_slot:GetName().."$o @HasJoinedTeam "..GameRules.TeamText[new_team]);
	end
	
  server_slot:Ready(nil);
  server_slot:ResetPlayTime();
end



Game:AddCommand("sv_swapteams","GameRules:DoSwitchTeams();","sv_swapteams");

